Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 12994)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 12996)
@@ -238,4 +238,12 @@
     [Storable]
     private BestAverageWorstQualityAnalyzer layerQualityAnalyzer;
+    [Storable]
+    private OldestAverageYoungestAgeAnalyzer ageAnalyzer;
+    [Storable]
+    private OldestAverageYoungestAgeAnalyzer layerAgeAnalyzer;
+    [Storable]
+    private AgeDistributionAnalyzer ageDistributionAnalyzer;
+    [Storable]
+    private AgeDistributionAnalyzer layerAgeDistributionAnalyzer;
     #endregion
 
@@ -251,4 +259,5 @@
     #endregion
 
+    #region Constructors
     [StorableConstructor]
     private AlpsGeneticAlgorithm(bool deserializing)
@@ -262,4 +271,8 @@
       qualityAnalyzer = cloner.Clone(original.qualityAnalyzer);
       layerQualityAnalyzer = cloner.Clone(original.layerQualityAnalyzer);
+      ageAnalyzer = cloner.Clone(original.ageAnalyzer);
+      layerAgeAnalyzer = cloner.Clone(original.layerAgeAnalyzer);
+      ageDistributionAnalyzer = cloner.Clone(original.ageDistributionAnalyzer);
+      layerAgeDistributionAnalyzer = cloner.Clone(original.layerAgeDistributionAnalyzer);
       generationsTerminator = cloner.Clone(original.generationsTerminator);
       evaluationsTerminator = cloner.Clone(original.evaluationsTerminator);
@@ -377,4 +390,8 @@
       qualityAnalyzer = new BestAverageWorstQualityAnalyzer();
       layerQualityAnalyzer = new BestAverageWorstQualityAnalyzer();
+      ageAnalyzer = new OldestAverageYoungestAgeAnalyzer();
+      layerAgeAnalyzer = new OldestAverageYoungestAgeAnalyzer();
+      ageDistributionAnalyzer = new AgeDistributionAnalyzer();
+      layerAgeDistributionAnalyzer = new AgeDistributionAnalyzer();
       #endregion
 
@@ -400,4 +417,5 @@
       Initialize();
     }
+    #endregion
 
     #region Events
@@ -569,5 +587,5 @@
       qualityAnalyzer.ResultsParameter.Hidden = true;
       qualityAnalyzer.QualityParameter.Depth = 2;
-      layerQualityAnalyzer.ResultsParameter.ActualName = "Results";
+      layerQualityAnalyzer.ResultsParameter.ActualName = "LayerResults";
       layerQualityAnalyzer.ResultsParameter.Hidden = true;
       layerQualityAnalyzer.QualityParameter.Depth = 1;
@@ -659,9 +677,14 @@
 
       Analyzer.Operators.Add(qualityAnalyzer, qualityAnalyzer.EnabledByDefault);
-      LayerAnalyzer.Operators.Add(layerQualityAnalyzer, layerQualityAnalyzer.EnabledByDefault);
+      Analyzer.Operators.Add(ageAnalyzer, ageAnalyzer.EnabledByDefault);
+      Analyzer.Operators.Add(ageDistributionAnalyzer, ageDistributionAnalyzer.EnabledByDefault);
+      LayerAnalyzer.Operators.Add(layerQualityAnalyzer, false);
+      LayerAnalyzer.Operators.Add(layerAgeAnalyzer, false);
+      LayerAnalyzer.Operators.Add(layerAgeDistributionAnalyzer, false);
 
       if (Problem != null) {
         foreach (var analyzer in Problem.Operators.OfType<IAnalyzer>()) {
           Analyzer.Operators.Add(analyzer, analyzer.EnabledByDefault);
+          LayerAnalyzer.Operators.Add((IAnalyzer)analyzer.Clone(), false);
         }
       }
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/EvaluatedSolutionsHistoryAnalyzer.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/EvaluatedSolutionsHistoryAnalyzer.cs	(revision 12994)
+++ 	(revision )
@@ -1,84 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Analysis;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Optimization.Operators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Algorithms.ALPS {
-  [Item("EvaluatedSolutionsHistoryAnalyzer", "")]
-  [StorableClass]
-  public sealed class EvaluatedSolutionsHistoryAnalyzer : AlgorithmOperator, IAnalyzer {
-    #region Parameter Properties
-    public ILookupParameter<IntValue> EvaluatedSolutionsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
-    }
-    public ILookupParameter<DataTable> EvaluatedSolutionsHistoryParameter {
-      get { return (ILookupParameter<DataTable>)Parameters["EvaluatedSolutionsHistory"]; }
-    }
-    public ValueLookupParameter<ResultCollection> ResultsParameter {
-      get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
-    }
-    #endregion
-
-    public bool EnabledByDefault { get { return false; } }
-
-    [StorableConstructor]
-    private EvaluatedSolutionsHistoryAnalyzer(bool deserializing)
-      : base(deserializing) { }
-    private EvaluatedSolutionsHistoryAnalyzer(EvaluatedSolutionsHistoryAnalyzer original, Cloner cloner)
-      : base(original, cloner) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new EvaluatedSolutionsHistoryAnalyzer(this, cloner);
-    }
-    public EvaluatedSolutionsHistoryAnalyzer()
-      : base() {
-      #region Create parameters
-      Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", ""));
-      Parameters.Add(new ValueLookupParameter<DataTable>("EvaluatedSolutionsHistory"));
-      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The results collection where the analysis values should be stored."));
-      #endregion 
-
-      #region Create operators
-      DataTableValuesCollector dataTableValuesCollector = new DataTableValuesCollector();
-      ResultsCollector resultsCollector = new ResultsCollector();
-
-      dataTableValuesCollector.CollectedValues.Add(new LookupParameter<IntValue>("EvaluatedSolutions", null, EvaluatedSolutionsParameter.Name));
-      dataTableValuesCollector.DataTableParameter.ActualName = EvaluatedSolutionsHistoryParameter.Name;
-
-      resultsCollector.CollectedValues.Add(new LookupParameter<DataTable>(EvaluatedSolutionsHistoryParameter.Name));
-      resultsCollector.ResultsParameter.ActualName = ResultsParameter.Name;
-      #endregion
-
-      #region Create operator graph
-      OperatorGraph.InitialOperator = dataTableValuesCollector;
-      dataTableValuesCollector.Successor = resultsCollector;
-      resultsCollector.Successor = null;
-      #endregion
-    }
-  }
-}
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeAnalyzer.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeAnalyzer.cs	(revision 12994)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeAnalyzer.cs	(revision 12996)
@@ -58,5 +58,5 @@
     #region Properties
     public bool EnabledByDefault {
-      get { return true; }
+      get { return false; }
     }
     private OldestAverageYoungestAgeCalculator OldestAverageYoungestAgeCalculator {
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12994)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12996)
@@ -133,5 +133,4 @@
   <ItemGroup>
     <Compile Include="AgeInheritance.cs" />
-    <Compile Include="Analyzers\EvaluatedSolutionsHistoryAnalyzer.cs" />
     <Compile Include="Analyzers\OldestAverageYoungestAgeAnalyzer.cs" />
     <Compile Include="Analyzers\AgeDistributionAnalyzer.cs" />