Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AgeInheritance.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AgeInheritance.cs	(revision 12996)
+++ 	(revision )
@@ -1,32 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Algorithms.ALPS {
-
-  /// <summary>
-  /// Defines how the age of a new individual is calculated during the crossover of two parent individuals.
-  /// </summary>
-  public enum AgeInheritance {
-    Older,
-    Agerage,
-    Younger
-  }
-}
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 12996)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 12997)
@@ -104,9 +104,6 @@
       get { return (IValueParameter<IntValue>)Parameters["AgeGap"]; }
     }
-    private IValueParameter<EnumValue<AgeInheritance>> AgeInheritanceParameter {
-      get { return (IValueParameter<EnumValue<AgeInheritance>>)Parameters["AgeInheritance"]; }
-    }
-    private IValueParameter<ReductionOperation> AgeInheritanceReductionParameter {
-      get { return (IValueParameter<ReductionOperation>)Parameters["AgeInheritanceReduction"]; }
+    private IValueParameter<DoubleValue> AgeInheritanceParameter {
+      get { return (IValueParameter<DoubleValue>)Parameters["AgeInheritance"]; }
     }
     private IValueParameter<IntArray> AgeLimitsParameter {
@@ -189,11 +186,7 @@
       set { AgeGapParameter.Value = value; }
     }
-    public EnumValue<AgeInheritance> AgeInheritance {
+    public DoubleValue AgeInheritance {
       get { return AgeInheritanceParameter.Value; }
       set { AgeInheritanceParameter.Value = value; }
-    }
-    private ReductionOperation AgeInheritanceReduction {
-      get { return AgeInheritanceReductionParameter.Value; }
-      set { AgeInheritanceReductionParameter.Value = value; }
     }
     public IntArray AgeLimits {
@@ -306,6 +299,5 @@
       Parameters.Add(new ValueParameter<EnumValue<AgingScheme>>("AgingScheme", "The aging scheme for setting the age-limits for the layers.", new EnumValue<AgingScheme>(ALPS.AgingScheme.Polynomial)));
       Parameters.Add(new ValueParameter<IntValue>("AgeGap", "The frequency of reseeding the lowest layer and scaling factor for the age-limits for the layers", new IntValue(20)));
-      Parameters.Add(new ValueParameter<EnumValue<AgeInheritance>>("AgeInheritance", "The operator for determining the age of an offspring based the parents' age.", new EnumValue<AgeInheritance>(ALPS.AgeInheritance.Older)));
-      Parameters.Add(new ValueParameter<ReductionOperation>("AgeInheritanceReduction") { Hidden = true });
+      Parameters.Add(new ValueParameter<DoubleValue>("AgeInheritance", "A weight that determines the age of a child after crossover based on the older (1.0) and younger (0.0) parent.", new DoubleValue(1.0)) { Hidden = true });
       Parameters.Add(new ValueParameter<IntArray>("AgeLimits", new IntArray(new int[0])) { Hidden = true });
 
@@ -404,6 +396,6 @@
 
       #region Parameterize
+      UpdateAnalyzers();
       ParameterizeAnalyzers();
-      UpdateAnalyzers();
 
       ParameterizeSelectors();
@@ -412,5 +404,4 @@
 
       ParameterizeAgeLimits();
-      ParameterizeAgeInheritanceReduction();
       #endregion
 
@@ -518,11 +509,4 @@
     private void NumberOfLayers_ValueChanged(object sender, EventArgs e) {
       ParameterizeAgeLimits();
-    }
-    private void AgeInheritanceParameter_ValueChanged(object sender, EventArgs e) {
-      AgeInheritance.ValueChanged += AgeInheritance_ValueChanged;
-      ParameterizeAgeInheritanceReduction();
-    }
-    private void AgeInheritance_ValueChanged(object sender, EventArgs e) {
-      ParameterizeAgeInheritanceReduction();
     }
 
@@ -564,6 +548,4 @@
       AgingSchemeParameter.ValueChanged += AgingSchemeParameter_ValueChanged;
       AgingScheme.ValueChanged += AgingScheme_ValueChanged;
-      AgeInheritanceParameter.ValueChanged += AgeInheritanceParameter_ValueChanged;
-      AgeInheritance.ValueChanged += AgeInheritance_ValueChanged;
 
       qualityAnalyzer.CurrentBestQualityParameter.NameChanged += new EventHandler(QualityAnalyzer_CurrentBestQualityParameter_NameChanged);
@@ -635,7 +617,4 @@
       }
     }
-    private void ParameterizeAgeInheritanceReduction() {
-      AgeInheritanceReduction.Value = GetAgeInheritanceReduction(AgeInheritance.Value);
-    }
     private void ParameterizeAgeLimits() {
       var scheme = AgingScheme.Value;
@@ -661,12 +640,4 @@
     }
 
-    private ReductionOperations GetAgeInheritanceReduction(AgeInheritance ageInheritance) {
-      switch (ageInheritance) {
-        case ALPS.AgeInheritance.Older: return ReductionOperations.Max;
-        case ALPS.AgeInheritance.Agerage: return ReductionOperations.Avg;
-        case ALPS.AgeInheritance.Younger: return ReductionOperations.Min;
-        default: throw new NotSupportedException("AgeInheritance " + ageInheritance + " is not supported.");
-      }
-    }
     #endregion
 
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithmMainLoop.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithmMainLoop.cs	(revision 12996)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithmMainLoop.cs	(revision 12997)
@@ -75,5 +75,5 @@
     public AlpsGeneticAlgorithmMainLoop()
       : base() {
-      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem, otherwise false.") { Hidden = true });
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The value which represents the quality of a solution."));
       Parameters.Add(new LookupParameter<IntValue>("MaximumGenerations", "The maximum number of generations that the algorithm should process."));
@@ -232,12 +232,10 @@
       // Insert AgeCalculator between crossover and its successor
       var crossoverSuccessor = crossover.Successor;
-      var ageCalculator = new DataReducer() { Name = "Calculate Age" };
+      var ageCalculator = new WeightingReducer() { Name = "Calculate Age" };
       crossover.Successor = ageCalculator;
 
       ageCalculator.ParameterToReduce.ActualName = "Age";
       ageCalculator.TargetParameter.ActualName = "Age";
-      ageCalculator.ReductionOperation.Value = null;
-      ageCalculator.ReductionOperation.ActualName = "AgeInheritanceReduction";
-      ageCalculator.TargetOperation.Value = new ReductionOperation(ReductionOperations.Assign);
+      ageCalculator.WeightParameter.ActualName = "AgeInheritance";
       ageCalculator.Successor = crossoverSuccessor;
 
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12996)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12997)
@@ -132,5 +132,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AgeInheritance.cs" />
+    <Compile Include="WeightingReducer.cs" />
     <Compile Include="Analyzers\OldestAverageYoungestAgeAnalyzer.cs" />
     <Compile Include="Analyzers\AgeDistributionAnalyzer.cs" />
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/WeightingReducer.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/WeightingReducer.cs	(revision 12997)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/WeightingReducer.cs	(revision 12997)
@@ -0,0 +1,81 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ALPS {
+  [Item("WeightingReducer", "An operator that combines two values based on the weight of the lower (0.0) and higher (1.0) value.")]
+  [StorableClass]
+  public sealed class WeightingReducer : SingleSuccessorOperator {
+
+    public ScopeTreeLookupParameter<IntValue> ParameterToReduce {
+      get { return (ScopeTreeLookupParameter<IntValue>)Parameters["ParameterToReduce"]; }
+    }
+    public LookupParameter<IntValue> TargetParameter {
+      get { return (LookupParameter<IntValue>)Parameters["TargetParameter"]; }
+    }
+    public IValueLookupParameter<DoubleValue> WeightParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Weight"]; }
+    }
+
+    [StorableConstructor]
+    private WeightingReducer(bool deserializing) : base(deserializing) { }
+    private WeightingReducer(WeightingReducer original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new WeightingReducer(this, cloner);
+    }
+    public WeightingReducer()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("ParameterToReduce", "The parameter on which the weighting should be applied."));
+      Parameters.Add(new LookupParameter<IntValue>("TargetParameter", "The target variable in which the weighted value should be stored."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Weight", "Weight of the two values (0.0 for the smaller, 1.0 for the larger)."));
+    }
+
+    public override IOperation Apply() {
+      var values = ParameterToReduce.ActualValue;
+      if (values.Length != 2)
+        throw new InvalidOperationException("Weighting between values can only done for two values.");
+
+      var weight = WeightParameter.ActualValue.Value;
+
+      var max = values.Max(v => v.Value);
+      var min = values.Min(v => v.Value);
+
+      int result = (int)(max * weight + min * (1 - weight));
+
+      if (TargetParameter.ActualValue == null)
+        TargetParameter.ActualValue = new IntValue(result);
+      else TargetParameter.ActualValue.Value = result;
+
+      return base.Apply();
+    }
+
+  }
+}